/*
 * Copyright 1996 1995 by Open Software Foundation, Inc. 1997 1996 1995 1994 1993 1992 1991  
 *              All Rights Reserved 
 *  
 * Permission to use, copy, modify, and distribute this software and 
 * its documentation for any purpose and without fee is hereby granted, 
 * provided that the above copyright notice appears in all copies and 
 * that both the copyright notice and this permission notice appear in 
 * supporting documentation. 
 *  
 * OSF DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE 
 * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
 * FOR A PARTICULAR PURPOSE. 
 *  
 * IN NO EVENT SHALL OSF BE LIABLE FOR ANY SPECIAL, INDIRECT, OR 
 * CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM 
 * LOSS OF USE, DATA OR PROFITS, WHETHER IN ACTION OF CONTRACT, 
 * NEGLIGENCE, OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION 
 * WITH THE USE OR PERFORMANCE OF THIS SOFTWARE. 
 */
/*
 * MkLinux_DR2.1_Update1
 */

/* Miscellaneous constants and structures used by the exception
 * handlers
 */

#ifndef _PPC_EXCEPTION_H_
#define _PPC_EXCEPTION_H_

#ifndef ASSEMBLER

#include <ppc/mem.h>
#include <cpus.h>
#include <ppc/thread_act.h>

/* When an exception is taken, this info is accessed via sprg0 */

struct per_proc_info {
	unsigned int save_cr;
	unsigned int save_srr0;
	unsigned int save_srr1;
	unsigned int save_exception_type;
	unsigned int phys_exception_handlers;
	unsigned int virt_per_proc_info; /* virt addr for our CPU */
	unsigned int active_kloaded;	/* pointer to active_kloaded[CPU_NO] */
	unsigned int cpu_data;		/* pointer to cpu_data[CPU_NO] */
	unsigned int active_stacks;	/* pointer to active_stacks[CPU_NO] */
	unsigned int need_ast;		/* pointer to need_ast[CPU_NO] */
	pcb_t	     fpu_pcb;		/* pcb owning the fpu on this cpu */
};

extern struct per_proc_info per_proc_info[NCPUS];

extern char *trap_type[];

#endif /* ndef ASSEMBLER */

#define EXC_VECTOR_SIZE		4		/* function pointer size */

/* Hardware exceptions */

#define EXC_INVALID		(0x00 * EXC_VECTOR_SIZE)
#define EXC_RESET		(0x01 * EXC_VECTOR_SIZE)
#define EXC_MACHINE_CHECK	(0x02 * EXC_VECTOR_SIZE)
#define EXC_DATA_ACCESS		(0x03 * EXC_VECTOR_SIZE)
#define EXC_INSTRUCTION_ACCESS	(0x04 * EXC_VECTOR_SIZE)
#define EXC_INTERRUPT		(0x05 * EXC_VECTOR_SIZE)
#define EXC_ALIGNMENT		(0x06 * EXC_VECTOR_SIZE)
#define EXC_PROGRAM		(0x07 * EXC_VECTOR_SIZE)
#define EXC_FP_UNAVAILABLE	(0x08 * EXC_VECTOR_SIZE)
#define EXC_DECREMENTER		(0x09 * EXC_VECTOR_SIZE)
#define EXC_IO_ERROR		(0x0a * EXC_VECTOR_SIZE)
#define EXC_RESERVED		(0x0b * EXC_VECTOR_SIZE)
#define EXC_SYSTEM_CALL		(0x0c * EXC_VECTOR_SIZE)
#define EXC_TRACE		(0x0d * EXC_VECTOR_SIZE)
#define EXC_FP_ASSIST		(0x0e * EXC_VECTOR_SIZE)
#define EXC_INSTRUCTION_BKPT	(0x13 * EXC_VECTOR_SIZE)
#define EXC_SYSTEM_MANAGEMENT	(0x14 * EXC_VECTOR_SIZE)

#define EXC_RUNMODE_TRACE	(0x20 * EXC_VECTOR_SIZE) /* 601 only */

/* software exceptions */

#define EXC_AST			(0x100 * EXC_VECTOR_SIZE) 
#define EXC_MAX			EXC_RUNMODE_TRACE /* Maximum exception no */

#endif /* _PPC_EXCEPTION_H_ */
